<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>AbstractConnPool xref</title>
<link type="text/css" rel="stylesheet" href="../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../apidocs/org/apache/http/pool/AbstractConnPool.html">View Javadoc</a></div><pre>

<a class="jxr_linenumber" name="1" href="#1">1</a>   <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="2" href="#2">2</a>   <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="3" href="#3">3</a>   <em class="jxr_comment"> * Licensed to the Apache Software Foundation (ASF) under one</em>
<a class="jxr_linenumber" name="4" href="#4">4</a>   <em class="jxr_comment"> * or more contributor license agreements.  See the NOTICE file</em>
<a class="jxr_linenumber" name="5" href="#5">5</a>   <em class="jxr_comment"> * distributed with this work for additional information</em>
<a class="jxr_linenumber" name="6" href="#6">6</a>   <em class="jxr_comment"> * regarding copyright ownership.  The ASF licenses this file</em>
<a class="jxr_linenumber" name="7" href="#7">7</a>   <em class="jxr_comment"> * to you under the Apache License, Version 2.0 (the</em>
<a class="jxr_linenumber" name="8" href="#8">8</a>   <em class="jxr_comment"> * "License"); you may not use this file except in compliance</em>
<a class="jxr_linenumber" name="9" href="#9">9</a>   <em class="jxr_comment"> * with the License.  You may obtain a copy of the License at</em>
<a class="jxr_linenumber" name="10" href="#10">10</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="11" href="#11">11</a>  <em class="jxr_comment"> *   <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a class="jxr_linenumber" name="12" href="#12">12</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="13" href="#13">13</a>  <em class="jxr_comment"> * Unless required by applicable law or agreed to in writing,</em>
<a class="jxr_linenumber" name="14" href="#14">14</a>  <em class="jxr_comment"> * software distributed under the License is distributed on an</em>
<a class="jxr_linenumber" name="15" href="#15">15</a>  <em class="jxr_comment"> * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY</em>
<a class="jxr_linenumber" name="16" href="#16">16</a>  <em class="jxr_comment"> * KIND, either express or implied.  See the License for the</em>
<a class="jxr_linenumber" name="17" href="#17">17</a>  <em class="jxr_comment"> * specific language governing permissions and limitations</em>
<a class="jxr_linenumber" name="18" href="#18">18</a>  <em class="jxr_comment"> * under the License.</em>
<a class="jxr_linenumber" name="19" href="#19">19</a>  <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="20" href="#20">20</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="21" href="#21">21</a>  <em class="jxr_comment"> * This software consists of voluntary contributions made by many</em>
<a class="jxr_linenumber" name="22" href="#22">22</a>  <em class="jxr_comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a class="jxr_linenumber" name="23" href="#23">23</a>  <em class="jxr_comment"> * information on the Apache Software Foundation, please see</em>
<a class="jxr_linenumber" name="24" href="#24">24</a>  <em class="jxr_comment"> * &lt;<a href="http://www.apache.org/&gt;." target="alexandria_uri">http://www.apache.org/&gt;.</a></em>
<a class="jxr_linenumber" name="25" href="#25">25</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="26" href="#26">26</a>  <em class="jxr_comment"> */</em>
<a class="jxr_linenumber" name="27" href="#27">27</a>  <strong class="jxr_keyword">package</strong> org.apache.http.pool;
<a class="jxr_linenumber" name="28" href="#28">28</a>  
<a class="jxr_linenumber" name="29" href="#29">29</a>  <strong class="jxr_keyword">import</strong> java.io.IOException;
<a class="jxr_linenumber" name="30" href="#30">30</a>  <strong class="jxr_keyword">import</strong> java.util.Date;
<a class="jxr_linenumber" name="31" href="#31">31</a>  <strong class="jxr_keyword">import</strong> java.util.HashMap;
<a class="jxr_linenumber" name="32" href="#32">32</a>  <strong class="jxr_keyword">import</strong> java.util.HashSet;
<a class="jxr_linenumber" name="33" href="#33">33</a>  <strong class="jxr_keyword">import</strong> java.util.Iterator;
<a class="jxr_linenumber" name="34" href="#34">34</a>  <strong class="jxr_keyword">import</strong> java.util.LinkedList;
<a class="jxr_linenumber" name="35" href="#35">35</a>  <strong class="jxr_keyword">import</strong> java.util.Map;
<a class="jxr_linenumber" name="36" href="#36">36</a>  <strong class="jxr_keyword">import</strong> java.util.Set;
<a class="jxr_linenumber" name="37" href="#37">37</a>  <strong class="jxr_keyword">import</strong> java.util.concurrent.Future;
<a class="jxr_linenumber" name="38" href="#38">38</a>  <strong class="jxr_keyword">import</strong> java.util.concurrent.TimeUnit;
<a class="jxr_linenumber" name="39" href="#39">39</a>  <strong class="jxr_keyword">import</strong> java.util.concurrent.TimeoutException;
<a class="jxr_linenumber" name="40" href="#40">40</a>  <strong class="jxr_keyword">import</strong> java.util.concurrent.locks.Lock;
<a class="jxr_linenumber" name="41" href="#41">41</a>  <strong class="jxr_keyword">import</strong> java.util.concurrent.locks.ReentrantLock;
<a class="jxr_linenumber" name="42" href="#42">42</a>  
<a class="jxr_linenumber" name="43" href="#43">43</a>  <strong class="jxr_keyword">import</strong> org.apache.http.annotation.ThreadSafe;
<a class="jxr_linenumber" name="44" href="#44">44</a>  <strong class="jxr_keyword">import</strong> org.apache.http.concurrent.FutureCallback;
<a class="jxr_linenumber" name="45" href="#45">45</a>  
<a class="jxr_linenumber" name="46" href="#46">46</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="47" href="#47">47</a>  <em class="jxr_javadoccomment"> * Abstract synchronous (blocking) pool of connections.</em>
<a class="jxr_linenumber" name="48" href="#48">48</a>  <em class="jxr_javadoccomment"> * &lt;p/&gt;</em>
<a class="jxr_linenumber" name="49" href="#49">49</a>  <em class="jxr_javadoccomment"> * Please note that this class does not maintain its own pool of execution {@link Thread}s.</em>
<a class="jxr_linenumber" name="50" href="#50">50</a>  <em class="jxr_javadoccomment"> * Therefore, one &lt;b&gt;must&lt;/b&gt; call {@link Future#get()} or {@link Future#get(long, TimeUnit)}</em>
<a class="jxr_linenumber" name="51" href="#51">51</a>  <em class="jxr_javadoccomment"> * method on the {@link Future} object returned by the</em>
<a class="jxr_linenumber" name="52" href="#52">52</a>  <em class="jxr_javadoccomment"> * {@link #lease(Object, Object, FutureCallback)} method in order for the lease operation</em>
<a class="jxr_linenumber" name="53" href="#53">53</a>  <em class="jxr_javadoccomment"> * to complete.</em>
<a class="jxr_linenumber" name="54" href="#54">54</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="55" href="#55">55</a>  <em class="jxr_javadoccomment"> * @param &lt;T&gt; the route type that represents the opposite endpoint of a pooled</em>
<a class="jxr_linenumber" name="56" href="#56">56</a>  <em class="jxr_javadoccomment"> *   connection.</em>
<a class="jxr_linenumber" name="57" href="#57">57</a>  <em class="jxr_javadoccomment"> * @param &lt;C&gt; the connection type.</em>
<a class="jxr_linenumber" name="58" href="#58">58</a>  <em class="jxr_javadoccomment"> * @param &lt;E&gt; the type of the pool entry containing a pooled connection.</em>
<a class="jxr_linenumber" name="59" href="#59">59</a>  <em class="jxr_javadoccomment"> * @since 4.2</em>
<a class="jxr_linenumber" name="60" href="#60">60</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="61" href="#61">61</a>  @ThreadSafe
<a class="jxr_linenumber" name="62" href="#62">62</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">abstract</strong> <strong class="jxr_keyword">class</strong> AbstractConnPool&lt;T, C, E <strong class="jxr_keyword">extends</strong> PoolEntry&lt;T, C&gt;&gt;
<a class="jxr_linenumber" name="63" href="#63">63</a>                                                 <strong class="jxr_keyword">implements</strong> ConnPool&lt;T, E&gt;, ConnPoolControl&lt;T&gt; {
<a class="jxr_linenumber" name="64" href="#64">64</a>  
<a class="jxr_linenumber" name="65" href="#65">65</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> Lock lock;
<a class="jxr_linenumber" name="66" href="#66">66</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> ConnFactory&lt;T, C&gt; connFactory;
<a class="jxr_linenumber" name="67" href="#67">67</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> Map&lt;T, RouteSpecificPool&lt;T, C, E&gt;&gt; routeToPool;
<a class="jxr_linenumber" name="68" href="#68">68</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> Set&lt;E&gt; leased;
<a class="jxr_linenumber" name="69" href="#69">69</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> LinkedList&lt;E&gt; available;
<a class="jxr_linenumber" name="70" href="#70">70</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> LinkedList&lt;PoolEntryFuture&lt;E&gt;&gt; pending;
<a class="jxr_linenumber" name="71" href="#71">71</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> Map&lt;T, Integer&gt; maxPerRoute;
<a class="jxr_linenumber" name="72" href="#72">72</a>  
<a class="jxr_linenumber" name="73" href="#73">73</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">volatile</strong> <strong class="jxr_keyword">boolean</strong> isShutDown;
<a class="jxr_linenumber" name="74" href="#74">74</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">volatile</strong> <strong class="jxr_keyword">int</strong> defaultMaxPerRoute;
<a class="jxr_linenumber" name="75" href="#75">75</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">volatile</strong> <strong class="jxr_keyword">int</strong> maxTotal;
<a class="jxr_linenumber" name="76" href="#76">76</a>  
<a class="jxr_linenumber" name="77" href="#77">77</a>      <strong class="jxr_keyword">public</strong> <a href="../../../../org/apache/http/pool/AbstractConnPool.html">AbstractConnPool</a>(
<a class="jxr_linenumber" name="78" href="#78">78</a>              <strong class="jxr_keyword">final</strong> ConnFactory&lt;T, C&gt; connFactory,
<a class="jxr_linenumber" name="79" href="#79">79</a>              <strong class="jxr_keyword">int</strong> defaultMaxPerRoute,
<a class="jxr_linenumber" name="80" href="#80">80</a>              <strong class="jxr_keyword">int</strong> maxTotal) {
<a class="jxr_linenumber" name="81" href="#81">81</a>          <strong class="jxr_keyword">super</strong>();
<a class="jxr_linenumber" name="82" href="#82">82</a>          <strong class="jxr_keyword">if</strong> (connFactory == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="83" href="#83">83</a>              <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalArgumentException(<span class="jxr_string">"Connection factory may not null"</span>);
<a class="jxr_linenumber" name="84" href="#84">84</a>          }
<a class="jxr_linenumber" name="85" href="#85">85</a>          <strong class="jxr_keyword">if</strong> (defaultMaxPerRoute &lt;= 0) {
<a class="jxr_linenumber" name="86" href="#86">86</a>              <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalArgumentException(<span class="jxr_string">"Max per route value may not be negative or zero"</span>);
<a class="jxr_linenumber" name="87" href="#87">87</a>          }
<a class="jxr_linenumber" name="88" href="#88">88</a>          <strong class="jxr_keyword">if</strong> (maxTotal &lt;= 0) {
<a class="jxr_linenumber" name="89" href="#89">89</a>              <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalArgumentException(<span class="jxr_string">"Max total value may not be negative or zero"</span>);
<a class="jxr_linenumber" name="90" href="#90">90</a>          }
<a class="jxr_linenumber" name="91" href="#91">91</a>          <strong class="jxr_keyword">this</strong>.lock = <strong class="jxr_keyword">new</strong> ReentrantLock();
<a class="jxr_linenumber" name="92" href="#92">92</a>          <strong class="jxr_keyword">this</strong>.connFactory = connFactory;
<a class="jxr_linenumber" name="93" href="#93">93</a>          <strong class="jxr_keyword">this</strong>.routeToPool = <strong class="jxr_keyword">new</strong> HashMap&lt;T, RouteSpecificPool&lt;T, C, E&gt;&gt;();
<a class="jxr_linenumber" name="94" href="#94">94</a>          <strong class="jxr_keyword">this</strong>.leased = <strong class="jxr_keyword">new</strong> HashSet&lt;E&gt;();
<a class="jxr_linenumber" name="95" href="#95">95</a>          <strong class="jxr_keyword">this</strong>.available = <strong class="jxr_keyword">new</strong> LinkedList&lt;E&gt;();
<a class="jxr_linenumber" name="96" href="#96">96</a>          <strong class="jxr_keyword">this</strong>.pending = <strong class="jxr_keyword">new</strong> LinkedList&lt;PoolEntryFuture&lt;E&gt;&gt;();
<a class="jxr_linenumber" name="97" href="#97">97</a>          <strong class="jxr_keyword">this</strong>.maxPerRoute = <strong class="jxr_keyword">new</strong> HashMap&lt;T, Integer&gt;();
<a class="jxr_linenumber" name="98" href="#98">98</a>          <strong class="jxr_keyword">this</strong>.defaultMaxPerRoute = defaultMaxPerRoute;
<a class="jxr_linenumber" name="99" href="#99">99</a>          <strong class="jxr_keyword">this</strong>.maxTotal = maxTotal;
<a class="jxr_linenumber" name="100" href="#100">100</a>     }
<a class="jxr_linenumber" name="101" href="#101">101</a> 
<a class="jxr_linenumber" name="102" href="#102">102</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="103" href="#103">103</a> <em class="jxr_javadoccomment">     * Creates a new entry for the given connection with the given route.</em>
<a class="jxr_linenumber" name="104" href="#104">104</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="105" href="#105">105</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">abstract</strong> E createEntry(T route, C conn);
<a class="jxr_linenumber" name="106" href="#106">106</a> 
<a class="jxr_linenumber" name="107" href="#107">107</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">boolean</strong> isShutdown() {
<a class="jxr_linenumber" name="108" href="#108">108</a>         <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">this</strong>.isShutDown;
<a class="jxr_linenumber" name="109" href="#109">109</a>     }
<a class="jxr_linenumber" name="110" href="#110">110</a> 
<a class="jxr_linenumber" name="111" href="#111">111</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="112" href="#112">112</a> <em class="jxr_javadoccomment">     * Shuts down the pool.</em>
<a class="jxr_linenumber" name="113" href="#113">113</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="114" href="#114">114</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> shutdown() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="115" href="#115">115</a>         <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.isShutDown) {
<a class="jxr_linenumber" name="116" href="#116">116</a>             <strong class="jxr_keyword">return</strong> ;
<a class="jxr_linenumber" name="117" href="#117">117</a>         }
<a class="jxr_linenumber" name="118" href="#118">118</a>         <strong class="jxr_keyword">this</strong>.isShutDown = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="119" href="#119">119</a>         <strong class="jxr_keyword">this</strong>.lock.lock();
<a class="jxr_linenumber" name="120" href="#120">120</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="121" href="#121">121</a>             <strong class="jxr_keyword">for</strong> (E entry: <strong class="jxr_keyword">this</strong>.available) {
<a class="jxr_linenumber" name="122" href="#122">122</a>                 entry.close();
<a class="jxr_linenumber" name="123" href="#123">123</a>             }
<a class="jxr_linenumber" name="124" href="#124">124</a>             <strong class="jxr_keyword">for</strong> (E entry: <strong class="jxr_keyword">this</strong>.leased) {
<a class="jxr_linenumber" name="125" href="#125">125</a>                 entry.close();
<a class="jxr_linenumber" name="126" href="#126">126</a>             }
<a class="jxr_linenumber" name="127" href="#127">127</a>             <strong class="jxr_keyword">for</strong> (RouteSpecificPool&lt;T, C, E&gt; pool: <strong class="jxr_keyword">this</strong>.routeToPool.values()) {
<a class="jxr_linenumber" name="128" href="#128">128</a>                 pool.shutdown();
<a class="jxr_linenumber" name="129" href="#129">129</a>             }
<a class="jxr_linenumber" name="130" href="#130">130</a>             <strong class="jxr_keyword">this</strong>.routeToPool.clear();
<a class="jxr_linenumber" name="131" href="#131">131</a>             <strong class="jxr_keyword">this</strong>.leased.clear();
<a class="jxr_linenumber" name="132" href="#132">132</a>             <strong class="jxr_keyword">this</strong>.available.clear();
<a class="jxr_linenumber" name="133" href="#133">133</a>         } <strong class="jxr_keyword">finally</strong> {
<a class="jxr_linenumber" name="134" href="#134">134</a>             <strong class="jxr_keyword">this</strong>.lock.unlock();
<a class="jxr_linenumber" name="135" href="#135">135</a>         }
<a class="jxr_linenumber" name="136" href="#136">136</a>     }
<a class="jxr_linenumber" name="137" href="#137">137</a> 
<a class="jxr_linenumber" name="138" href="#138">138</a>     <strong class="jxr_keyword">private</strong> RouteSpecificPool&lt;T, C, E&gt; getPool(<strong class="jxr_keyword">final</strong> T route) {
<a class="jxr_linenumber" name="139" href="#139">139</a>         RouteSpecificPool&lt;T, C, E&gt; pool = <strong class="jxr_keyword">this</strong>.routeToPool.get(route);
<a class="jxr_linenumber" name="140" href="#140">140</a>         <strong class="jxr_keyword">if</strong> (pool == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="141" href="#141">141</a>             pool = <strong class="jxr_keyword">new</strong> RouteSpecificPool&lt;T, C, E&gt;(route) {
<a class="jxr_linenumber" name="142" href="#142">142</a> 
<a class="jxr_linenumber" name="143" href="#143">143</a>                 @Override
<a class="jxr_linenumber" name="144" href="#144">144</a>                 <strong class="jxr_keyword">protected</strong> E createEntry(C conn) {
<a class="jxr_linenumber" name="145" href="#145">145</a>                     <strong class="jxr_keyword">return</strong> AbstractConnPool.<strong class="jxr_keyword">this</strong>.createEntry(route, conn);
<a class="jxr_linenumber" name="146" href="#146">146</a>                 }
<a class="jxr_linenumber" name="147" href="#147">147</a> 
<a class="jxr_linenumber" name="148" href="#148">148</a>             };
<a class="jxr_linenumber" name="149" href="#149">149</a>             <strong class="jxr_keyword">this</strong>.routeToPool.put(route, pool);
<a class="jxr_linenumber" name="150" href="#150">150</a>         }
<a class="jxr_linenumber" name="151" href="#151">151</a>         <strong class="jxr_keyword">return</strong> pool;
<a class="jxr_linenumber" name="152" href="#152">152</a>     }
<a class="jxr_linenumber" name="153" href="#153">153</a> 
<a class="jxr_linenumber" name="154" href="#154">154</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="155" href="#155">155</a> <em class="jxr_javadoccomment">     * {@inheritDoc}</em>
<a class="jxr_linenumber" name="156" href="#156">156</a> <em class="jxr_javadoccomment">     * &lt;p/&gt;</em>
<a class="jxr_linenumber" name="157" href="#157">157</a> <em class="jxr_javadoccomment">     * Please note that this class does not maintain its own pool of execution</em>
<a class="jxr_linenumber" name="158" href="#158">158</a> <em class="jxr_javadoccomment">     * {@link Thread}s. Therefore, one &lt;b&gt;must&lt;/b&gt; call {@link Future#get()}</em>
<a class="jxr_linenumber" name="159" href="#159">159</a> <em class="jxr_javadoccomment">     * or {@link Future#get(long, TimeUnit)} method on the {@link Future}</em>
<a class="jxr_linenumber" name="160" href="#160">160</a> <em class="jxr_javadoccomment">     * returned by this method in order for the lease operation to complete.</em>
<a class="jxr_linenumber" name="161" href="#161">161</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="162" href="#162">162</a>     <strong class="jxr_keyword">public</strong> Future&lt;E&gt; lease(<strong class="jxr_keyword">final</strong> T route, <strong class="jxr_keyword">final</strong> Object state, <strong class="jxr_keyword">final</strong> FutureCallback&lt;E&gt; callback) {
<a class="jxr_linenumber" name="163" href="#163">163</a>         <strong class="jxr_keyword">if</strong> (route == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="164" href="#164">164</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalArgumentException(<span class="jxr_string">"Route may not be null"</span>);
<a class="jxr_linenumber" name="165" href="#165">165</a>         }
<a class="jxr_linenumber" name="166" href="#166">166</a>         <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.isShutDown) {
<a class="jxr_linenumber" name="167" href="#167">167</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalStateException(<span class="jxr_string">"Connection pool shut down"</span>);
<a class="jxr_linenumber" name="168" href="#168">168</a>         }
<a class="jxr_linenumber" name="169" href="#169">169</a>         <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">new</strong> PoolEntryFuture&lt;E&gt;(<strong class="jxr_keyword">this</strong>.lock, callback) {
<a class="jxr_linenumber" name="170" href="#170">170</a> 
<a class="jxr_linenumber" name="171" href="#171">171</a>             @Override
<a class="jxr_linenumber" name="172" href="#172">172</a>             <strong class="jxr_keyword">public</strong> E getPoolEntry(
<a class="jxr_linenumber" name="173" href="#173">173</a>                     <strong class="jxr_keyword">long</strong> timeout,
<a class="jxr_linenumber" name="174" href="#174">174</a>                     TimeUnit tunit)
<a class="jxr_linenumber" name="175" href="#175">175</a>                         <strong class="jxr_keyword">throws</strong> InterruptedException, TimeoutException, IOException {
<a class="jxr_linenumber" name="176" href="#176">176</a>                 <strong class="jxr_keyword">return</strong> getPoolEntryBlocking(route, state, timeout, tunit, <strong class="jxr_keyword">this</strong>);
<a class="jxr_linenumber" name="177" href="#177">177</a>             }
<a class="jxr_linenumber" name="178" href="#178">178</a> 
<a class="jxr_linenumber" name="179" href="#179">179</a>         };
<a class="jxr_linenumber" name="180" href="#180">180</a>     }
<a class="jxr_linenumber" name="181" href="#181">181</a> 
<a class="jxr_linenumber" name="182" href="#182">182</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="183" href="#183">183</a> <em class="jxr_javadoccomment">     * Attempts to lease a connection for the given route and with the given</em>
<a class="jxr_linenumber" name="184" href="#184">184</a> <em class="jxr_javadoccomment">     * state from the pool.</em>
<a class="jxr_linenumber" name="185" href="#185">185</a> <em class="jxr_javadoccomment">     * &lt;p/&gt;</em>
<a class="jxr_linenumber" name="186" href="#186">186</a> <em class="jxr_javadoccomment">     * Please note that this class does not maintain its own pool of execution</em>
<a class="jxr_linenumber" name="187" href="#187">187</a> <em class="jxr_javadoccomment">     * {@link Thread}s. Therefore, one &lt;b&gt;must&lt;/b&gt; call {@link Future#get()}</em>
<a class="jxr_linenumber" name="188" href="#188">188</a> <em class="jxr_javadoccomment">     * or {@link Future#get(long, TimeUnit)} method on the {@link Future}</em>
<a class="jxr_linenumber" name="189" href="#189">189</a> <em class="jxr_javadoccomment">     * returned by this method in order for the lease operation to complete.</em>
<a class="jxr_linenumber" name="190" href="#190">190</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="191" href="#191">191</a> <em class="jxr_javadoccomment">     * @param route route of the connection.</em>
<a class="jxr_linenumber" name="192" href="#192">192</a> <em class="jxr_javadoccomment">     * @param state arbitrary object that represents a particular state</em>
<a class="jxr_linenumber" name="193" href="#193">193</a> <em class="jxr_javadoccomment">     *  (usually a security principal or a unique token identifying</em>
<a class="jxr_linenumber" name="194" href="#194">194</a> <em class="jxr_javadoccomment">     *  the user whose credentials have been used while establishing the connection).</em>
<a class="jxr_linenumber" name="195" href="#195">195</a> <em class="jxr_javadoccomment">     *  May be &lt;code&gt;null&lt;/code&gt;.</em>
<a class="jxr_linenumber" name="196" href="#196">196</a> <em class="jxr_javadoccomment">     * @return future for a leased pool entry.</em>
<a class="jxr_linenumber" name="197" href="#197">197</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="198" href="#198">198</a>     <strong class="jxr_keyword">public</strong> Future&lt;E&gt; lease(<strong class="jxr_keyword">final</strong> T route, <strong class="jxr_keyword">final</strong> Object state) {
<a class="jxr_linenumber" name="199" href="#199">199</a>         <strong class="jxr_keyword">return</strong> lease(route, state, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="200" href="#200">200</a>     }
<a class="jxr_linenumber" name="201" href="#201">201</a> 
<a class="jxr_linenumber" name="202" href="#202">202</a>     <strong class="jxr_keyword">private</strong> E getPoolEntryBlocking(
<a class="jxr_linenumber" name="203" href="#203">203</a>             <strong class="jxr_keyword">final</strong> T route, <strong class="jxr_keyword">final</strong> Object state,
<a class="jxr_linenumber" name="204" href="#204">204</a>             <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">long</strong> timeout, <strong class="jxr_keyword">final</strong> TimeUnit tunit,
<a class="jxr_linenumber" name="205" href="#205">205</a>             <strong class="jxr_keyword">final</strong> PoolEntryFuture&lt;E&gt; future)
<a class="jxr_linenumber" name="206" href="#206">206</a>                 <strong class="jxr_keyword">throws</strong> IOException, InterruptedException, TimeoutException {
<a class="jxr_linenumber" name="207" href="#207">207</a> 
<a class="jxr_linenumber" name="208" href="#208">208</a>         Date deadline = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="209" href="#209">209</a>         <strong class="jxr_keyword">if</strong> (timeout &gt; 0) {
<a class="jxr_linenumber" name="210" href="#210">210</a>             deadline = <strong class="jxr_keyword">new</strong> Date
<a class="jxr_linenumber" name="211" href="#211">211</a>                 (System.currentTimeMillis() + tunit.toMillis(timeout));
<a class="jxr_linenumber" name="212" href="#212">212</a>         }
<a class="jxr_linenumber" name="213" href="#213">213</a> 
<a class="jxr_linenumber" name="214" href="#214">214</a>         <strong class="jxr_keyword">this</strong>.lock.lock();
<a class="jxr_linenumber" name="215" href="#215">215</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="216" href="#216">216</a>             RouteSpecificPool&lt;T, C, E&gt; pool = getPool(route);
<a class="jxr_linenumber" name="217" href="#217">217</a>             E entry = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="218" href="#218">218</a>             <strong class="jxr_keyword">while</strong> (entry == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="219" href="#219">219</a>                 <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.isShutDown) {
<a class="jxr_linenumber" name="220" href="#220">220</a>                     <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalStateException(<span class="jxr_string">"Connection pool shut down"</span>);
<a class="jxr_linenumber" name="221" href="#221">221</a>                 }
<a class="jxr_linenumber" name="222" href="#222">222</a>                 <strong class="jxr_keyword">for</strong> (;;) {
<a class="jxr_linenumber" name="223" href="#223">223</a>                     entry = pool.getFree(state);
<a class="jxr_linenumber" name="224" href="#224">224</a>                     <strong class="jxr_keyword">if</strong> (entry == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="225" href="#225">225</a>                         <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="226" href="#226">226</a>                     }
<a class="jxr_linenumber" name="227" href="#227">227</a>                     <strong class="jxr_keyword">if</strong> (entry.isClosed() || entry.isExpired(System.currentTimeMillis())) {
<a class="jxr_linenumber" name="228" href="#228">228</a>                         entry.close();
<a class="jxr_linenumber" name="229" href="#229">229</a>                         <strong class="jxr_keyword">this</strong>.available.remove(entry);
<a class="jxr_linenumber" name="230" href="#230">230</a>                         pool.free(entry, false);
<a class="jxr_linenumber" name="231" href="#231">231</a>                     } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="232" href="#232">232</a>                         <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="233" href="#233">233</a>                     }
<a class="jxr_linenumber" name="234" href="#234">234</a>                 }
<a class="jxr_linenumber" name="235" href="#235">235</a>                 <strong class="jxr_keyword">if</strong> (entry != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="236" href="#236">236</a>                     <strong class="jxr_keyword">this</strong>.available.remove(entry);
<a class="jxr_linenumber" name="237" href="#237">237</a>                     <strong class="jxr_keyword">this</strong>.leased.add(entry);
<a class="jxr_linenumber" name="238" href="#238">238</a>                     <strong class="jxr_keyword">return</strong> entry;
<a class="jxr_linenumber" name="239" href="#239">239</a>                 }
<a class="jxr_linenumber" name="240" href="#240">240</a> 
<a class="jxr_linenumber" name="241" href="#241">241</a>                 <em class="jxr_comment">// New connection is needed</em>
<a class="jxr_linenumber" name="242" href="#242">242</a>                 <strong class="jxr_keyword">int</strong> maxPerRoute = getMax(route);
<a class="jxr_linenumber" name="243" href="#243">243</a>                 <em class="jxr_comment">// Shrink the pool prior to allocating a new connection</em>
<a class="jxr_linenumber" name="244" href="#244">244</a>                 <strong class="jxr_keyword">int</strong> excess = Math.max(0, pool.getAllocatedCount() + 1 - maxPerRoute);
<a class="jxr_linenumber" name="245" href="#245">245</a>                 <strong class="jxr_keyword">if</strong> (excess &gt; 0) {
<a class="jxr_linenumber" name="246" href="#246">246</a>                     <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 0; i &lt; excess; i++) {
<a class="jxr_linenumber" name="247" href="#247">247</a>                         E lastUsed = pool.getLastUsed();
<a class="jxr_linenumber" name="248" href="#248">248</a>                         <strong class="jxr_keyword">if</strong> (lastUsed == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="249" href="#249">249</a>                             <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="250" href="#250">250</a>                         }
<a class="jxr_linenumber" name="251" href="#251">251</a>                         lastUsed.close();
<a class="jxr_linenumber" name="252" href="#252">252</a>                         <strong class="jxr_keyword">this</strong>.available.remove(lastUsed);
<a class="jxr_linenumber" name="253" href="#253">253</a>                         pool.remove(lastUsed);
<a class="jxr_linenumber" name="254" href="#254">254</a>                     }
<a class="jxr_linenumber" name="255" href="#255">255</a>                 }
<a class="jxr_linenumber" name="256" href="#256">256</a> 
<a class="jxr_linenumber" name="257" href="#257">257</a>                 <strong class="jxr_keyword">if</strong> (pool.getAllocatedCount() &lt; maxPerRoute) {
<a class="jxr_linenumber" name="258" href="#258">258</a>                     <strong class="jxr_keyword">int</strong> totalUsed = <strong class="jxr_keyword">this</strong>.leased.size();
<a class="jxr_linenumber" name="259" href="#259">259</a>                     <strong class="jxr_keyword">int</strong> freeCapacity = Math.max(<strong class="jxr_keyword">this</strong>.maxTotal - totalUsed, 0);
<a class="jxr_linenumber" name="260" href="#260">260</a>                     <strong class="jxr_keyword">if</strong> (freeCapacity &gt; 0) {
<a class="jxr_linenumber" name="261" href="#261">261</a>                         <strong class="jxr_keyword">int</strong> totalAvailable = <strong class="jxr_keyword">this</strong>.available.size();
<a class="jxr_linenumber" name="262" href="#262">262</a>                         <strong class="jxr_keyword">if</strong> (totalAvailable &gt; freeCapacity - 1) {
<a class="jxr_linenumber" name="263" href="#263">263</a>                             <strong class="jxr_keyword">if</strong> (!<strong class="jxr_keyword">this</strong>.available.isEmpty()) {
<a class="jxr_linenumber" name="264" href="#264">264</a>                                 E lastUsed = <strong class="jxr_keyword">this</strong>.available.removeLast();
<a class="jxr_linenumber" name="265" href="#265">265</a>                                 lastUsed.close();
<a class="jxr_linenumber" name="266" href="#266">266</a>                                 RouteSpecificPool&lt;T, C, E&gt; otherpool = getPool(lastUsed.getRoute());
<a class="jxr_linenumber" name="267" href="#267">267</a>                                 otherpool.remove(lastUsed);
<a class="jxr_linenumber" name="268" href="#268">268</a>                             }
<a class="jxr_linenumber" name="269" href="#269">269</a>                         }
<a class="jxr_linenumber" name="270" href="#270">270</a>                         C conn = <strong class="jxr_keyword">this</strong>.connFactory.create(route);
<a class="jxr_linenumber" name="271" href="#271">271</a>                         entry = pool.add(conn);
<a class="jxr_linenumber" name="272" href="#272">272</a>                         <strong class="jxr_keyword">this</strong>.leased.add(entry);
<a class="jxr_linenumber" name="273" href="#273">273</a>                         <strong class="jxr_keyword">return</strong> entry;
<a class="jxr_linenumber" name="274" href="#274">274</a>                     }
<a class="jxr_linenumber" name="275" href="#275">275</a>                 }
<a class="jxr_linenumber" name="276" href="#276">276</a> 
<a class="jxr_linenumber" name="277" href="#277">277</a>                 <strong class="jxr_keyword">boolean</strong> success = false;
<a class="jxr_linenumber" name="278" href="#278">278</a>                 <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="279" href="#279">279</a>                     pool.queue(future);
<a class="jxr_linenumber" name="280" href="#280">280</a>                     <strong class="jxr_keyword">this</strong>.pending.add(future);
<a class="jxr_linenumber" name="281" href="#281">281</a>                     success = future.await(deadline);
<a class="jxr_linenumber" name="282" href="#282">282</a>                 } <strong class="jxr_keyword">finally</strong> {
<a class="jxr_linenumber" name="283" href="#283">283</a>                     <em class="jxr_comment">// In case of 'success', we were woken up by the</em>
<a class="jxr_linenumber" name="284" href="#284">284</a>                     <em class="jxr_comment">// connection pool and should now have a connection</em>
<a class="jxr_linenumber" name="285" href="#285">285</a>                     <em class="jxr_comment">// waiting for us, or else we're shutting down.</em>
<a class="jxr_linenumber" name="286" href="#286">286</a>                     <em class="jxr_comment">// Just continue in the loop, both cases are checked.</em>
<a class="jxr_linenumber" name="287" href="#287">287</a>                     pool.unqueue(future);
<a class="jxr_linenumber" name="288" href="#288">288</a>                     <strong class="jxr_keyword">this</strong>.pending.remove(future);
<a class="jxr_linenumber" name="289" href="#289">289</a>                 }
<a class="jxr_linenumber" name="290" href="#290">290</a>                 <em class="jxr_comment">// check for spurious wakeup vs. timeout</em>
<a class="jxr_linenumber" name="291" href="#291">291</a>                 <strong class="jxr_keyword">if</strong> (!success &amp;&amp; (deadline != <strong class="jxr_keyword">null</strong>) &amp;&amp;
<a class="jxr_linenumber" name="292" href="#292">292</a>                     (deadline.getTime() &lt;= System.currentTimeMillis())) {
<a class="jxr_linenumber" name="293" href="#293">293</a>                     <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="294" href="#294">294</a>                 }
<a class="jxr_linenumber" name="295" href="#295">295</a>             }
<a class="jxr_linenumber" name="296" href="#296">296</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> TimeoutException(<span class="jxr_string">"Timeout waiting for connection"</span>);
<a class="jxr_linenumber" name="297" href="#297">297</a>         } <strong class="jxr_keyword">finally</strong> {
<a class="jxr_linenumber" name="298" href="#298">298</a>             <strong class="jxr_keyword">this</strong>.lock.unlock();
<a class="jxr_linenumber" name="299" href="#299">299</a>         }
<a class="jxr_linenumber" name="300" href="#300">300</a>     }
<a class="jxr_linenumber" name="301" href="#301">301</a> 
<a class="jxr_linenumber" name="302" href="#302">302</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> notifyPending(<strong class="jxr_keyword">final</strong> RouteSpecificPool&lt;T, C, E&gt; pool) {
<a class="jxr_linenumber" name="303" href="#303">303</a>         PoolEntryFuture&lt;E&gt; future = pool.nextPending();
<a class="jxr_linenumber" name="304" href="#304">304</a>         <strong class="jxr_keyword">if</strong> (future != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="305" href="#305">305</a>             <strong class="jxr_keyword">this</strong>.pending.remove(future);
<a class="jxr_linenumber" name="306" href="#306">306</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="307" href="#307">307</a>             future = <strong class="jxr_keyword">this</strong>.pending.poll();
<a class="jxr_linenumber" name="308" href="#308">308</a>         }
<a class="jxr_linenumber" name="309" href="#309">309</a>         <strong class="jxr_keyword">if</strong> (future != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="310" href="#310">310</a>             future.wakeup();
<a class="jxr_linenumber" name="311" href="#311">311</a>         }
<a class="jxr_linenumber" name="312" href="#312">312</a>     }
<a class="jxr_linenumber" name="313" href="#313">313</a> 
<a class="jxr_linenumber" name="314" href="#314">314</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> release(E entry, <strong class="jxr_keyword">boolean</strong> reusable) {
<a class="jxr_linenumber" name="315" href="#315">315</a>         <strong class="jxr_keyword">this</strong>.lock.lock();
<a class="jxr_linenumber" name="316" href="#316">316</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="317" href="#317">317</a>             <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.leased.remove(entry)) {
<a class="jxr_linenumber" name="318" href="#318">318</a>                 RouteSpecificPool&lt;T, C, E&gt; pool = getPool(entry.getRoute());
<a class="jxr_linenumber" name="319" href="#319">319</a>                 pool.free(entry, reusable);
<a class="jxr_linenumber" name="320" href="#320">320</a>                 <strong class="jxr_keyword">if</strong> (reusable &amp;&amp; !<strong class="jxr_keyword">this</strong>.isShutDown) {
<a class="jxr_linenumber" name="321" href="#321">321</a>                     <strong class="jxr_keyword">this</strong>.available.addFirst(entry);
<a class="jxr_linenumber" name="322" href="#322">322</a>                 } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="323" href="#323">323</a>                     entry.close();
<a class="jxr_linenumber" name="324" href="#324">324</a>                 }
<a class="jxr_linenumber" name="325" href="#325">325</a>                 notifyPending(pool);
<a class="jxr_linenumber" name="326" href="#326">326</a>             }
<a class="jxr_linenumber" name="327" href="#327">327</a>         } <strong class="jxr_keyword">finally</strong> {
<a class="jxr_linenumber" name="328" href="#328">328</a>             <strong class="jxr_keyword">this</strong>.lock.unlock();
<a class="jxr_linenumber" name="329" href="#329">329</a>         }
<a class="jxr_linenumber" name="330" href="#330">330</a>     }
<a class="jxr_linenumber" name="331" href="#331">331</a> 
<a class="jxr_linenumber" name="332" href="#332">332</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">int</strong> getMax(<strong class="jxr_keyword">final</strong> T route) {
<a class="jxr_linenumber" name="333" href="#333">333</a>         Integer v = <strong class="jxr_keyword">this</strong>.maxPerRoute.get(route);
<a class="jxr_linenumber" name="334" href="#334">334</a>         <strong class="jxr_keyword">if</strong> (v != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="335" href="#335">335</a>             <strong class="jxr_keyword">return</strong> v.intValue();
<a class="jxr_linenumber" name="336" href="#336">336</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="337" href="#337">337</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">this</strong>.defaultMaxPerRoute;
<a class="jxr_linenumber" name="338" href="#338">338</a>         }
<a class="jxr_linenumber" name="339" href="#339">339</a>     }
<a class="jxr_linenumber" name="340" href="#340">340</a> 
<a class="jxr_linenumber" name="341" href="#341">341</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setMaxTotal(<strong class="jxr_keyword">int</strong> max) {
<a class="jxr_linenumber" name="342" href="#342">342</a>         <strong class="jxr_keyword">if</strong> (max &lt;= 0) {
<a class="jxr_linenumber" name="343" href="#343">343</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalArgumentException(<span class="jxr_string">"Max value may not be negative or zero"</span>);
<a class="jxr_linenumber" name="344" href="#344">344</a>         }
<a class="jxr_linenumber" name="345" href="#345">345</a>         <strong class="jxr_keyword">this</strong>.lock.lock();
<a class="jxr_linenumber" name="346" href="#346">346</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="347" href="#347">347</a>             <strong class="jxr_keyword">this</strong>.maxTotal = max;
<a class="jxr_linenumber" name="348" href="#348">348</a>         } <strong class="jxr_keyword">finally</strong> {
<a class="jxr_linenumber" name="349" href="#349">349</a>             <strong class="jxr_keyword">this</strong>.lock.unlock();
<a class="jxr_linenumber" name="350" href="#350">350</a>         }
<a class="jxr_linenumber" name="351" href="#351">351</a>     }
<a class="jxr_linenumber" name="352" href="#352">352</a> 
<a class="jxr_linenumber" name="353" href="#353">353</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">int</strong> getMaxTotal() {
<a class="jxr_linenumber" name="354" href="#354">354</a>         <strong class="jxr_keyword">this</strong>.lock.lock();
<a class="jxr_linenumber" name="355" href="#355">355</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="356" href="#356">356</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">this</strong>.maxTotal;
<a class="jxr_linenumber" name="357" href="#357">357</a>         } <strong class="jxr_keyword">finally</strong> {
<a class="jxr_linenumber" name="358" href="#358">358</a>             <strong class="jxr_keyword">this</strong>.lock.unlock();
<a class="jxr_linenumber" name="359" href="#359">359</a>         }
<a class="jxr_linenumber" name="360" href="#360">360</a>     }
<a class="jxr_linenumber" name="361" href="#361">361</a> 
<a class="jxr_linenumber" name="362" href="#362">362</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setDefaultMaxPerRoute(<strong class="jxr_keyword">int</strong> max) {
<a class="jxr_linenumber" name="363" href="#363">363</a>         <strong class="jxr_keyword">if</strong> (max &lt;= 0) {
<a class="jxr_linenumber" name="364" href="#364">364</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalArgumentException(<span class="jxr_string">"Max value may not be negative or zero"</span>);
<a class="jxr_linenumber" name="365" href="#365">365</a>         }
<a class="jxr_linenumber" name="366" href="#366">366</a>         <strong class="jxr_keyword">this</strong>.lock.lock();
<a class="jxr_linenumber" name="367" href="#367">367</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="368" href="#368">368</a>             <strong class="jxr_keyword">this</strong>.defaultMaxPerRoute = max;
<a class="jxr_linenumber" name="369" href="#369">369</a>         } <strong class="jxr_keyword">finally</strong> {
<a class="jxr_linenumber" name="370" href="#370">370</a>             <strong class="jxr_keyword">this</strong>.lock.unlock();
<a class="jxr_linenumber" name="371" href="#371">371</a>         }
<a class="jxr_linenumber" name="372" href="#372">372</a>     }
<a class="jxr_linenumber" name="373" href="#373">373</a> 
<a class="jxr_linenumber" name="374" href="#374">374</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">int</strong> getDefaultMaxPerRoute() {
<a class="jxr_linenumber" name="375" href="#375">375</a>         <strong class="jxr_keyword">this</strong>.lock.lock();
<a class="jxr_linenumber" name="376" href="#376">376</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="377" href="#377">377</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">this</strong>.defaultMaxPerRoute;
<a class="jxr_linenumber" name="378" href="#378">378</a>         } <strong class="jxr_keyword">finally</strong> {
<a class="jxr_linenumber" name="379" href="#379">379</a>             <strong class="jxr_keyword">this</strong>.lock.unlock();
<a class="jxr_linenumber" name="380" href="#380">380</a>         }
<a class="jxr_linenumber" name="381" href="#381">381</a>     }
<a class="jxr_linenumber" name="382" href="#382">382</a> 
<a class="jxr_linenumber" name="383" href="#383">383</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setMaxPerRoute(<strong class="jxr_keyword">final</strong> T route, <strong class="jxr_keyword">int</strong> max) {
<a class="jxr_linenumber" name="384" href="#384">384</a>         <strong class="jxr_keyword">if</strong> (route == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="385" href="#385">385</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalArgumentException(<span class="jxr_string">"Route may not be null"</span>);
<a class="jxr_linenumber" name="386" href="#386">386</a>         }
<a class="jxr_linenumber" name="387" href="#387">387</a>         <strong class="jxr_keyword">if</strong> (max &lt;= 0) {
<a class="jxr_linenumber" name="388" href="#388">388</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalArgumentException(<span class="jxr_string">"Max value may not be negative or zero"</span>);
<a class="jxr_linenumber" name="389" href="#389">389</a>         }
<a class="jxr_linenumber" name="390" href="#390">390</a>         <strong class="jxr_keyword">this</strong>.lock.lock();
<a class="jxr_linenumber" name="391" href="#391">391</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="392" href="#392">392</a>             <strong class="jxr_keyword">this</strong>.maxPerRoute.put(route, max);
<a class="jxr_linenumber" name="393" href="#393">393</a>         } <strong class="jxr_keyword">finally</strong> {
<a class="jxr_linenumber" name="394" href="#394">394</a>             <strong class="jxr_keyword">this</strong>.lock.unlock();
<a class="jxr_linenumber" name="395" href="#395">395</a>         }
<a class="jxr_linenumber" name="396" href="#396">396</a>     }
<a class="jxr_linenumber" name="397" href="#397">397</a> 
<a class="jxr_linenumber" name="398" href="#398">398</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">int</strong> getMaxPerRoute(T route) {
<a class="jxr_linenumber" name="399" href="#399">399</a>         <strong class="jxr_keyword">if</strong> (route == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="400" href="#400">400</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalArgumentException(<span class="jxr_string">"Route may not be null"</span>);
<a class="jxr_linenumber" name="401" href="#401">401</a>         }
<a class="jxr_linenumber" name="402" href="#402">402</a>         <strong class="jxr_keyword">this</strong>.lock.lock();
<a class="jxr_linenumber" name="403" href="#403">403</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="404" href="#404">404</a>             <strong class="jxr_keyword">return</strong> getMax(route);
<a class="jxr_linenumber" name="405" href="#405">405</a>         } <strong class="jxr_keyword">finally</strong> {
<a class="jxr_linenumber" name="406" href="#406">406</a>             <strong class="jxr_keyword">this</strong>.lock.unlock();
<a class="jxr_linenumber" name="407" href="#407">407</a>         }
<a class="jxr_linenumber" name="408" href="#408">408</a>     }
<a class="jxr_linenumber" name="409" href="#409">409</a> 
<a class="jxr_linenumber" name="410" href="#410">410</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../org/apache/http/pool/PoolStats.html">PoolStats</a> getTotalStats() {
<a class="jxr_linenumber" name="411" href="#411">411</a>         <strong class="jxr_keyword">this</strong>.lock.lock();
<a class="jxr_linenumber" name="412" href="#412">412</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="413" href="#413">413</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../org/apache/http/pool/PoolStats.html">PoolStats</a>(
<a class="jxr_linenumber" name="414" href="#414">414</a>                     <strong class="jxr_keyword">this</strong>.leased.size(),
<a class="jxr_linenumber" name="415" href="#415">415</a>                     <strong class="jxr_keyword">this</strong>.pending.size(),
<a class="jxr_linenumber" name="416" href="#416">416</a>                     <strong class="jxr_keyword">this</strong>.available.size(),
<a class="jxr_linenumber" name="417" href="#417">417</a>                     <strong class="jxr_keyword">this</strong>.maxTotal);
<a class="jxr_linenumber" name="418" href="#418">418</a>         } <strong class="jxr_keyword">finally</strong> {
<a class="jxr_linenumber" name="419" href="#419">419</a>             <strong class="jxr_keyword">this</strong>.lock.unlock();
<a class="jxr_linenumber" name="420" href="#420">420</a>         }
<a class="jxr_linenumber" name="421" href="#421">421</a>     }
<a class="jxr_linenumber" name="422" href="#422">422</a> 
<a class="jxr_linenumber" name="423" href="#423">423</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../org/apache/http/pool/PoolStats.html">PoolStats</a> getStats(<strong class="jxr_keyword">final</strong> T route) {
<a class="jxr_linenumber" name="424" href="#424">424</a>         <strong class="jxr_keyword">if</strong> (route == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="425" href="#425">425</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalArgumentException(<span class="jxr_string">"Route may not be null"</span>);
<a class="jxr_linenumber" name="426" href="#426">426</a>         }
<a class="jxr_linenumber" name="427" href="#427">427</a>         <strong class="jxr_keyword">this</strong>.lock.lock();
<a class="jxr_linenumber" name="428" href="#428">428</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="429" href="#429">429</a>             RouteSpecificPool&lt;T, C, E&gt; pool = getPool(route);
<a class="jxr_linenumber" name="430" href="#430">430</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../org/apache/http/pool/PoolStats.html">PoolStats</a>(
<a class="jxr_linenumber" name="431" href="#431">431</a>                     pool.getLeasedCount(),
<a class="jxr_linenumber" name="432" href="#432">432</a>                     pool.getPendingCount(),
<a class="jxr_linenumber" name="433" href="#433">433</a>                     pool.getAvailableCount(),
<a class="jxr_linenumber" name="434" href="#434">434</a>                     getMax(route));
<a class="jxr_linenumber" name="435" href="#435">435</a>         } <strong class="jxr_keyword">finally</strong> {
<a class="jxr_linenumber" name="436" href="#436">436</a>             <strong class="jxr_keyword">this</strong>.lock.unlock();
<a class="jxr_linenumber" name="437" href="#437">437</a>         }
<a class="jxr_linenumber" name="438" href="#438">438</a>     }
<a class="jxr_linenumber" name="439" href="#439">439</a> 
<a class="jxr_linenumber" name="440" href="#440">440</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="441" href="#441">441</a> <em class="jxr_javadoccomment">     * Closes connections that have been idle longer than the given period</em>
<a class="jxr_linenumber" name="442" href="#442">442</a> <em class="jxr_javadoccomment">     * of time and evicts them from the pool.</em>
<a class="jxr_linenumber" name="443" href="#443">443</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="444" href="#444">444</a> <em class="jxr_javadoccomment">     * @param idletime maximum idle time.</em>
<a class="jxr_linenumber" name="445" href="#445">445</a> <em class="jxr_javadoccomment">     * @param tunit time unit.</em>
<a class="jxr_linenumber" name="446" href="#446">446</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="447" href="#447">447</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> closeIdle(<strong class="jxr_keyword">long</strong> idletime, <strong class="jxr_keyword">final</strong> TimeUnit tunit) {
<a class="jxr_linenumber" name="448" href="#448">448</a>         <strong class="jxr_keyword">if</strong> (tunit == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="449" href="#449">449</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalArgumentException(<span class="jxr_string">"Time unit must not be null."</span>);
<a class="jxr_linenumber" name="450" href="#450">450</a>         }
<a class="jxr_linenumber" name="451" href="#451">451</a>         <strong class="jxr_keyword">long</strong> time = tunit.toMillis(idletime);
<a class="jxr_linenumber" name="452" href="#452">452</a>         <strong class="jxr_keyword">if</strong> (time &lt; 0) {
<a class="jxr_linenumber" name="453" href="#453">453</a>             time = 0;
<a class="jxr_linenumber" name="454" href="#454">454</a>         }
<a class="jxr_linenumber" name="455" href="#455">455</a>         <strong class="jxr_keyword">long</strong> deadline = System.currentTimeMillis() - time;
<a class="jxr_linenumber" name="456" href="#456">456</a>         <strong class="jxr_keyword">this</strong>.lock.lock();
<a class="jxr_linenumber" name="457" href="#457">457</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="458" href="#458">458</a>             Iterator&lt;E&gt; it = <strong class="jxr_keyword">this</strong>.available.iterator();
<a class="jxr_linenumber" name="459" href="#459">459</a>             <strong class="jxr_keyword">while</strong> (it.hasNext()) {
<a class="jxr_linenumber" name="460" href="#460">460</a>                 E entry = it.next();
<a class="jxr_linenumber" name="461" href="#461">461</a>                 <strong class="jxr_keyword">if</strong> (entry.getUpdated() &lt;= deadline) {
<a class="jxr_linenumber" name="462" href="#462">462</a>                     entry.close();
<a class="jxr_linenumber" name="463" href="#463">463</a>                     RouteSpecificPool&lt;T, C, E&gt; pool = getPool(entry.getRoute());
<a class="jxr_linenumber" name="464" href="#464">464</a>                     pool.remove(entry);
<a class="jxr_linenumber" name="465" href="#465">465</a>                     it.remove();
<a class="jxr_linenumber" name="466" href="#466">466</a>                     notifyPending(pool);
<a class="jxr_linenumber" name="467" href="#467">467</a>                 }
<a class="jxr_linenumber" name="468" href="#468">468</a>             }
<a class="jxr_linenumber" name="469" href="#469">469</a>         } <strong class="jxr_keyword">finally</strong> {
<a class="jxr_linenumber" name="470" href="#470">470</a>             <strong class="jxr_keyword">this</strong>.lock.unlock();
<a class="jxr_linenumber" name="471" href="#471">471</a>         }
<a class="jxr_linenumber" name="472" href="#472">472</a>     }
<a class="jxr_linenumber" name="473" href="#473">473</a> 
<a class="jxr_linenumber" name="474" href="#474">474</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="475" href="#475">475</a> <em class="jxr_javadoccomment">     * Closes expired connections and evicts them from the pool.</em>
<a class="jxr_linenumber" name="476" href="#476">476</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="477" href="#477">477</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> closeExpired() {
<a class="jxr_linenumber" name="478" href="#478">478</a>         <strong class="jxr_keyword">long</strong> now = System.currentTimeMillis();
<a class="jxr_linenumber" name="479" href="#479">479</a>         <strong class="jxr_keyword">this</strong>.lock.lock();
<a class="jxr_linenumber" name="480" href="#480">480</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="481" href="#481">481</a>             Iterator&lt;E&gt; it = <strong class="jxr_keyword">this</strong>.available.iterator();
<a class="jxr_linenumber" name="482" href="#482">482</a>             <strong class="jxr_keyword">while</strong> (it.hasNext()) {
<a class="jxr_linenumber" name="483" href="#483">483</a>                 E entry = it.next();
<a class="jxr_linenumber" name="484" href="#484">484</a>                 <strong class="jxr_keyword">if</strong> (entry.isExpired(now)) {
<a class="jxr_linenumber" name="485" href="#485">485</a>                     entry.close();
<a class="jxr_linenumber" name="486" href="#486">486</a>                     RouteSpecificPool&lt;T, C, E&gt; pool = getPool(entry.getRoute());
<a class="jxr_linenumber" name="487" href="#487">487</a>                     pool.remove(entry);
<a class="jxr_linenumber" name="488" href="#488">488</a>                     it.remove();
<a class="jxr_linenumber" name="489" href="#489">489</a>                     notifyPending(pool);
<a class="jxr_linenumber" name="490" href="#490">490</a>                 }
<a class="jxr_linenumber" name="491" href="#491">491</a>             }
<a class="jxr_linenumber" name="492" href="#492">492</a>         } <strong class="jxr_keyword">finally</strong> {
<a class="jxr_linenumber" name="493" href="#493">493</a>             <strong class="jxr_keyword">this</strong>.lock.unlock();
<a class="jxr_linenumber" name="494" href="#494">494</a>         }
<a class="jxr_linenumber" name="495" href="#495">495</a>     }
<a class="jxr_linenumber" name="496" href="#496">496</a> 
<a class="jxr_linenumber" name="497" href="#497">497</a>     @Override
<a class="jxr_linenumber" name="498" href="#498">498</a>     <strong class="jxr_keyword">public</strong> String toString() {
<a class="jxr_linenumber" name="499" href="#499">499</a>         StringBuilder buffer = <strong class="jxr_keyword">new</strong> StringBuilder();
<a class="jxr_linenumber" name="500" href="#500">500</a>         buffer.append(<span class="jxr_string">"[leased: "</span>);
<a class="jxr_linenumber" name="501" href="#501">501</a>         buffer.append(<strong class="jxr_keyword">this</strong>.leased);
<a class="jxr_linenumber" name="502" href="#502">502</a>         buffer.append(<span class="jxr_string">"][available: "</span>);
<a class="jxr_linenumber" name="503" href="#503">503</a>         buffer.append(<strong class="jxr_keyword">this</strong>.available);
<a class="jxr_linenumber" name="504" href="#504">504</a>         buffer.append(<span class="jxr_string">"][pending: "</span>);
<a class="jxr_linenumber" name="505" href="#505">505</a>         buffer.append(<strong class="jxr_keyword">this</strong>.pending);
<a class="jxr_linenumber" name="506" href="#506">506</a>         buffer.append(<span class="jxr_string">"]"</span>);
<a class="jxr_linenumber" name="507" href="#507">507</a>         <strong class="jxr_keyword">return</strong> buffer.toString();
<a class="jxr_linenumber" name="508" href="#508">508</a>     }
<a class="jxr_linenumber" name="509" href="#509">509</a> 
<a class="jxr_linenumber" name="510" href="#510">510</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

